/*     BIBLIOTHEQUE 

Le module constitue le point d'entre de l'application.
Il dmarre l'application et ralise le routage des demandes
Chaque domaine dispose de son module (les auteurs, les livres ...)

DJ 17.11.2014
*/


// *** Le serveur et l'application
var express = require('X:/.../express');
var app = express(); // ejs est inclus
var bodyParser = require('X:/.../body-parser'); // pour rcuprer les donnes des formulaires
app.use(bodyParser.urlencoded({ extended: false }));
var cookieParser = require('X:/.../cookie-parser');
app.use(cookieParser());

// *** Les modules par domaine
var oaccueil= require("./controleurs/accueil");
var oauteurs= require("./controleurs/auteurs");
var ocategs= require("./controleurs/categories");
var olivres= require("./controleurs/livres");
var orech= require("./controleurs/recherche");
require("X:/.../constantes"); 
// non nomm. Les donnes sont accessibles par leur nom non qualifi, ce qui ne ncessite pas de faire un nouveau require.

// *** Lien statique sur les feuilles de style
// css est l'alias, utilis dans stylesheet du fichier ejs,  pour le repertoire 'public/stylesheets'
app.use('/css', express.static('X:/.../public/stylesheets'));


// *** Routage des demandes
// accueil
app.get('/', function(req, res) {
	oaccueil.accueil( req, res);	
});
app.get(c_accueil_url, function(req, res) {
	oaccueil.accueil( req, res);	
});

// auteurs
app.get(c_auteurs_url_liste, function(req, res) {
	oauteurs.liste( req, res);	
});
app.get(c_auteurs_url_ajout, function(req, res) {
	oauteurs.ajout( req, res);	
});
app.get(c_auteurs_url_modif, function(req, res) {
	oauteurs.modif( req, res);	
});
app.post(c_auteurs_url_valid_ajout, function(req, res) {
	oauteurs.ajoutvalid( req, res);	
});
app.get(c_auteurs_url_valid_suppr, function(req, res) {
	oauteurs.supprvalid( req, res);	
});

// categories
app.get(c_categories_url_liste, function(req, res) {
	ocategs.liste( req, res);	
});
app.get(c_categories_url_ajout, function(req, res) {
	ocategs.ajout( req, res);	
});
app.get(c_categories_url_modif, function(req, res) {
	ocategs.modif( req, res);	
});
app.post(c_categories_url_valid_ajout, function(req, res) {
	ocategs.ajoutvalid( req, res);	
});
app.get(c_categories_url_valid_suppr, function(req, res) {
	ocategs.supprvalid( req, res);	
});

// livres
app.get(c_livres_url_liste, function(req, res) {
	olivres.liste( req, res);	
});
app.get(c_livres_url_ajout, function(req, res) {
	olivres.ajout( req, res);	
});
app.get(c_livres_url_modif, function(req, res) {
	olivres.modif( req, res);	
});
app.post(c_livres_url_valid_ajout, function(req, res) {
	olivres.ajoutvalid( req, res);	
});
app.get(c_livres_url_valid_suppr, function(req, res) {
	olivres.supprvalid( req, res);	
});
app.get(c_livres_url_recherche, function(req, res) {
	orech.saisie( req, res);	
});
app.post(c_livres_url_valid_recherche, function(req, res) {
	orech.saisievalid( req, res);	
});
app.get(c_livres_url_rech_raz, function(req, res) {
	orech.saisieraz( req, res);	
});


// *** Dmarrage du serveur
// le serveur n' pas besoin d'etre redmarr si on change une page ejs
app.listen(8080);

