/*     BIBLIOTHEQUE 

Le module gre les fonctions de la base de donnes

DJ 05.10.2014
*/


/*-------------------------------------------------------------------------------------------------
OUVERTURE DE LA BASE
-------------------------------------------------------------------------------------------------*/

function ouv_base() {

	var file = "Y:/.../development.sqlite3";
	var sqlite3 = require("X:/.../sqlite3/sqlite3").verbose();
	var db = new sqlite3.Database(file);

	return db;

}



/*-------------------------------------------------------------------------------------------------
MISE A JOUR DE LA BASE ET RETOUR A LA LISTE
-------------------------------------------------------------------------------------------------*/

function maj_base(request, response, sql, url_liste) {

	var db=ouv_base();
	db.run (sql, function() {
			//-----  Retour  la liste des categories aprs maj
			response.writeHead(302, {'Location': url_liste });
			response.end();			

			}
		);

}



/*-------------------------------------------------------------------------------------------------
CHARGEMENT LISTE DES AUTEURS
-------------------------------------------------------------------------------------------------*/

function charger_liste_auteurs(  request, response, zechange, callback) {
	
	var db=ouv_base();
	db.serialize(function() {
  
	// lecture de la base de donnes
	
	zechange.liste_auteurs=[];
		var i = 0;
	var req="SELECT * from auteurs order by autabr";
	db.each(req, 
		
		// cette fonction de callback stocke chaque ligne lue
		function(err, row) {
			// passer l'enreg. auteur + les critres de slection prcdents		
			zechange.liste_auteurs[i]=row;
			i++;
		} 

		,
		// cette fonction de callback est active lorsque le traitement de la requete est termin
		// err=message d'erreur     nbr=nombre de lignes lues
		function(err, nbr) {

			//Appel de la fonction suivante
			callback();
			
		}

	);

	});

}



/*-------------------------------------------------------------------------------------------------
CHARGEMENT LISTE DES CATEGORIES
-------------------------------------------------------------------------------------------------*/

function charger_liste_categories(  request, response, zechange, callback) {
	
	var db=ouv_base();
	db.serialize(function() {
  
	// lecture de la base de donnes
	
	zechange.liste_categories=[];
	var i = 0;
	var req="SELECT * from categories order by catlib";
	db.each(req, 
		
		// cette fonction de callback stocke chaque ligne lue
		function(err, row) {
			// passer l'enreg. auteur + les critres de slection prcdents		
			zechange.liste_categories[i]=row;
			i++;
		} 

		,
		// cette fonction de callback est active lorsque le traitement de la requete est termin
		// err=message d'erreur     nbr=nombre de lignes lues
		function(err, nbr) {

			//Appel de la fonction suivante
			callback();
			
		}

	);

	});

}




// le nom externe est different du nom interne 
exports.ouverture_base = ouv_base;
exports.maj_base = maj_base;
exports.charger_liste_auteurs = charger_liste_auteurs;
exports.charger_liste_categories = charger_liste_categories;
