/*     BIBLIOTHEQUE 

Le module gre les fonctions associes aux catgories
	. liste
	. ajout
	. modification
	. validation de l'ajout/modif
	. suppression
	. validation
	
DJ 29.11.2014
*/


// Modules
var omep=require('X:/.../controleurs/presentation');
var odb=require("X:/.../basedonnees");
var ogen=require('X:/.../controleurs/general');

// exportation des fonctions
exports.liste = liste;
exports.ajout = ajout;
exports.modif = modif;
exports.ajoutvalid = ajoutvalid;
exports.supprvalid = supprvalid;


// domaine concern pour personnaliser notamment les scripts intgrs dans la page finale
var domaine = "categories";

/*-------------------------------------------------------------------------------------------------
LISTE DES CATEGORIES
-------------------------------------------------------------------------------------------------*/

function liste(request, response) {

	/* Description de la fonction 
	Le coeur du traitement est la fonction db.each qui reoit 3 paramtres :
		. la requte sql
		. la fonction de callback pour chaque ligne lue (concatnation avec les lignes prcdentes)
		. la fonction de callback quand toute la requte est lue (criture de la page)

	Elle est srialise pour s'assurer de recevoir les donnes dans l'ordre voulu.

	*/
	
	var zechange=ogen.init_zechange("LISTE DES CATEGORIES", domaine);

	var db=odb.ouverture_base();
	db.serialize(function() {
  
	// lecture de la base de donnes et stockage dans un tableau
	var req="SELECT a.catid, a.catlib from categories a ";
	req += "order by catlib";
	var i = 0;

	db.each(req, 
		
		// cette fonction de callback traite chaque ligne lue
		function(err, row) {
			zechange.liste[i]=row;
			i++;
			} 

		,
		// cette fonction de callback est active lorsque le traitement de la requete est termin
		// err=message d'erreur     nbr=nombre de lignes lues
		function(err, nbr) {
		
			// intgration dans la page complte et affichage
			omep.afficher_page(request, response, c_categories_vue_liste, zechange);
			
			}

		);
  

	});

}



/*-------------------------------------------------------------------------------------------------
AJOUT D'UNE CATEGORIE - AFFICHAGE FORMULAIRE
-------------------------------------------------------------------------------------------------*/

function ajout(req, response) {
	console.log("Execution de l'ajout d'une categorie.");

	var zechange=ogen.init_zechange("AJOUT D'UNE CATEGORIE", domaine);
	zechange.ligne.catid=0;

	// afficher le formulaire avec l'objet cr
	omep.afficher_page(req, response, c_categories_vue_modif, zechange);

}



/*-------------------------------------------------------------------------------------------------
MODIFICATION D'UNE CATEGORIE - AFFICHAGE FORMULAIRE
-------------------------------------------------------------------------------------------------*/

function modif(request, response) {
	console.log("Execution de la modification d'une categorie.");

	// Rcupration des variables de l'url (id  modifier)
	//var pid=request.query.id;  //avec la syntaxe /modif?id=xxx
	var pid = request.params.idcat; // avec la syntaxe /modif/:idcat

	var zechange=ogen.init_zechange("MODIFICATION D'UNE CATEGORIE", domaine);

    var db=odb.ouverture_base();
    db.serialize(function() {
  
	// lecture de la base de donnes pour alimenter l'objet
	var req="SELECT a.catid, a.catlib ";
	req += "from categories a ";
	req += "where a.catid = " + pid;

	db.each(req, 
		
		// cette fonction de callback traite chaque ligne lue (1 seule ici)
		function(err, row) {
			// renseigner l'objet avec les valeurs lues
			zechange.ligne=row;
			} 

		,
		// cette fonction de callback est active lorsque le traitement de la requete est termin
		function() {
			// afficher le formulaire de saisie pour l'objet
			omep.afficher_page(request, response, c_categories_vue_modif, zechange);
			}

		);
  

	});

}

/*-------------------------------------------------------------------------------------------------
VALIDATION DE L'AJOUT/MODIF D'UNE CATEGORIE
	. lecture des donnes du formulaire
	. contrle
	. maj de la base
-------------------------------------------------------------------------------------------------*/

function ajoutvalid(request, response) {

	console.log("validation de l'ajout/modif d'une categorie");

	//-----  Lecture du formulaire

	if (request.method != 'POST') {
		return;
	}

	var zechange=ogen.init_zechange("MODIFICATION D'UNE CATEGORIE", domaine);
	zechange.ligne.catid=request.body.zid;
	zechange.ligne.catlib=request.body.zcatlib;


	//-----  Controle des donnes
	if (zechange.ligne.catid == 0) {
		zechange.titre = "AJOUT CATEGORIE APRES ERREUR";
		}
	else {
		zechange.titre = "MODIF CATEGORIE APRES ERREUR";
		}

	zechange.ligne.meserr="";
	var inderr = 0;

	// intitul obligatoire
	if (inderr == 0 && zechange.ligne.catlib=="") {
		inderr=1;
		zechange.ligne.meserr="L' intitule est obligatoire";
		}
	
	// si erreur, afficher le message au bas de l'cran
	if (inderr == 1) {
			omep.afficher_page(request, response, c_categories_vue_modif, zechange);
			return;
			}
		
//-----  Maj de la base
		// ... calcul requete
		var sql="";
		
		if (zechange.ligne.catid == 0) {
			// ajout d'une categorie
			sql = "insert into categories (catlib) values('"
			sql += zechange.ligne.catlib;
			sql += "')";
			}
			else
			{
			// modification d'une categorie
			sql = "update categories set "
			sql += "catlib = '" + zechange.ligne.catlib + "'";
			sql += " where catid=" + zechange.ligne.catid;
			}

		// ... execution requete et retour  la liste des categories
		odb.maj_base(request, response, sql, c_categories_url_liste);
}



/*-------------------------------------------------------------------------------------------------
VALIDATION DE LA SUPPRESSION D'UNE CATEGORIE
	. lecture de l'id  supprimer dans l'url
	. maj de la base
-------------------------------------------------------------------------------------------------*/

function supprvalid(request, response) {

	console.log("validation de la suppression d'une categorie");

	// Rcupration des variables de l'url (id  modifier)
	var params = request.query;
	var pid = params.id;

	//-----  Maj de la base
	// ... calcul requete
	var sql="";
	sql = "delete from categories where catid=" + pid;

	// ... execution requete et retour  la liste des categories
	odb.maj_base(request, response, sql, c_categories_url_liste);

}