/*     BIBLIOTHEQUE 

Le module gre les fonctions associes aux livres
	. liste des livres
	. ajout d'un livre
	. modification d'un livre
	. validation de l'ajout/modif
	. suppression d'un livre
	. validation de la suppression

Les fonctions d'ajout et de modification sont trs similaires.
L'ajout doit grer le chargement des listes droulantes auteurs et catgories et l'affichage du formulaire de saisie.
La modification doit en plus afficher les donnes du livre.

Les fonctions sur les listes doivent tre enchaines les unes  la suite des autres d'o la structure en appels imbriqus.

DJ 07.12.2014
*/



// Modules
var omep=require('X:/.../controleurs/presentation');
var odb=require("X:/.../basedonnees");
var ogen=require('X:/.../controleurs/general');


// exportation des fonctions
exports.liste = liste;
exports.ajout = ajout;
exports.modif = modif;
exports.ajoutvalid = ajoutvalid;
exports.supprvalid = supprvalid;


// domaine concern pour personnaliser notamment les scripts intgrs dans la page finale
var domaine = "livres";



/*-------------------------------------------------------------------------------------------------
LISTE DES LIVRES
-------------------------------------------------------------------------------------------------*/

function liste(request, response) {

	/* Description de la fonction 
	Le coeur du traitement est la fonction db.each qui reoit 3 paramtres :
		. la requte sql
		. la fonction de callback pour chaque ligne lue (concatnation avec les lignes prcdentes)
		. la fonction de callback quand toute la requte est lue (criture de la page)

	Elle est srialise pour s'assurer de recevoir les donnes dans l'ordre voulu.

	*/
	
	var zechange=ogen.init_zechange("LISTE DES LIVRES", domaine);

	var db=odb.ouverture_base();
	db.serialize(function() {
  
		// lecture de la base de donnes et stockage dans un tableau

		// ... rcupration des critres de slection dans les cookies 
		var zwhere = "where 1=1 ";
	
		if (request.cookies.cklivaut) {
			zwhere += "and a.auteur_id = " + request.cookies.cklivaut + " ";
		}

		if (request.cookies.cklivtit) {
			zwhere += "and a.livtit like '%" + request.cookies.cklivtit + "%' ";
		}
	
		if (request.cookies.cklivcat) {
			zwhere += "and a.livcat = " + request.cookies.cklivcat + " ";
		}
	

		// ... constitution de la requete
		var req="SELECT a.id, a.livtit, b.autnom,  c.catlib ";
		req += "from livres a ";
		req += "inner join auteurs    b on b.id = a.auteur_id ";
		req += "inner join categories c on c.catid = a.livcat ";
		req += zwhere;
		req += "order by b.autabr asc, a.livtit asc";
		var i = 0;

		db.each(req, 
		
			// cette fonction de callback traite chaque ligne lue
			function(err, row) {
				zechange.liste[i]=row;
				i++;
			} 

			,
			// cette fonction de callback est active lorsque le traitement de la requete est termin
			// err=message d'erreur     nbr=nombre de lignes lues
			function(err, nbr) {
		
				// intgration dans la page complte et affichage
				omep.afficher_page(request, response, c_livres_vue_liste, zechange);
			}

		);
  
	});

}



/*-------------------------------------------------------------------------------------------------
AJOUT D'UN LIVRE - AFFICHAGE FORMULAIRE
-------------------------------------------------------------------------------------------------*/

function ajout(request, response) {
	console.log("Execution de l'ajout d'un livre.");

	var zechange=ogen.init_zechange("AJOUT D'UN LIVRE", domaine);
	zechange.ligne.id=0;

	// afficher le formulaire avec l'objet cr
	charger_donnees_afficher (request, response, zechange);

}



/*-------------------------------------------------------------------------------------------------
MODIFICATION D'UN LIVRE - AFFICHAGE FORMULAIRE
-------------------------------------------------------------------------------------------------*/

function modif(request, response) {
	console.log("Execution de la modification d'un livre.");


	// Rcupration des variables de l'url (id  modifier)
	var pid=request.query.id;  //avec la syntaxe /modif?id=xxx
	
	var zechange=ogen.init_zechange("MODIFICATION D'UN LIVRE", domaine);

	var db=odb.ouverture_base();
	db.serialize(function() {
  
		// lecture de la base de donnes pour alimenter l'objet
		var req="SELECT a.id, a.livtit, a.auteur_id, a.livcat ";
		req += "from livres a ";
		req += "where a.id = " + pid;

		db.each(req, 
		
			// cette fonction de callback traite chaque ligne lue (1 seule ici)
			function(err, row) {
				// renseigner l'objet avec les valeurs lues
				zechange.ligne=row;
			} 
	
			,
			// cette fonction de callback est active lorsque le traitement de la requete est termin
			function() {
				// afficher le formulaire de saisie pour l'objet
				charger_donnees_afficher (request, response, zechange);
			}

		);
	});

}



/*-------------------------------------------------------------------------------------------------
VALIDATION DE L'AJOUT/MODIF D'UN LIVRE
	. lecture des donnes du formulaire
	. contrle
	. maj de la base
-------------------------------------------------------------------------------------------------*/

function ajoutvalid(request, response) {

	console.log("validation de l'ajout/modif d'un livre");


	//-----  Lecture du formulaire

	if (request.method != 'POST') {
		return;
	}

	var zechange=ogen.init_zechange("MODIFICATION D'UN LIVRE", domaine);
	zechange.ligne.id=request.body.zid;
	zechange.ligne.livtit=request.body.zlivtit;
	zechange.ligne.auteur_id=request.body.zlivaut;
	zechange.ligne.livcat=request.body.zlivcat;

	//-----  Controle des donnes
	if (zechange.ligne.id == 0) {
		zechange.titre = "AJOUT LIVRE APRES ERREUR";
	}
	else {
		zechange.titre = "MODIF LIVRE APRES ERREUR";
	}

	zechange.ligne.meserr="";
	var inderr = 0;

	// titre obligatoire
	if (inderr == 0 && zechange.ligne.livtit=="") {
		inderr=1;
		zechange.ligne.meserr="Le titre est obligatoire";
	}
	

	// auteur obligatoire
	if (inderr == 0 && zechange.ligne.auteur_id=="") {
		inderr=1;
		zechange.ligne.meserr="L'auteur est obligatoire";
	}
		
	// catgorie obligatoire
	if (inderr == 0 && zechange.ligne.livcat=="") {
		inderr=1;
		zechange.ligne.meserr="La categorie est obligatoire";
	}
		
	// si erreur, afficher le message au bas de l'cran
	if (inderr == 1) {
		charger_donnees_afficher (request, response, zechange);
		return;
	}
		
	//-----  Maj de la base
	// ... calcul requete
	var sql="";
		
	if (zechange.ligne.id == 0) {
		// ajout d'un auteur
		sql = "insert into livres (livtit, auteur_id, livcat) values('"
		sql += zechange.ligne.livtit;
		sql += "', '";
		sql += zechange.ligne.auteur_id;
		sql += "', '";
		sql += zechange.ligne.livcat;
		sql += "')";
	}
	else
	{
		// modification d'un auteur
		sql = "update livres set "
		sql += "livtit = '" + zechange.ligne.livtit + "'";
		sql += ", ";
		sql += "auteur_id = " + zechange.ligne.auteur_id;
		sql += ", ";
		sql += "livcat = " + zechange.ligne.livcat;
		sql += " where id=" + zechange.ligne.id;
	}

	// ... execution requete avec retour  la liste des livres	
	odb.maj_base(request, response, sql, c_livres_url_liste);
		
}



/*-------------------------------------------------------------------------------------------------
VALIDATION DE LA SUPPRESSION D'UN LIVRE
	. lecture de l'id  supprimer dans l'url
	. maj de la base
-------------------------------------------------------------------------------------------------*/

function supprvalid(request, response) {

	console.log("validation de la suppression d'un livre");


	// Rcupration des variables de l'url (id  modifier)
	var params = request.query;
	var pid = params.id;

	//-----  Maj de la base
	// ... calcul requete
	var sql="";
	sql = "delete from livres where id=" + pid;

	// ... execution requete
	odb.maj_base(request, response, sql, c_livres_url_liste);

}



/*-------------------------------------------------------------------------------------------------
CHARGEMENT DES DONNEES COMMUNES A L' AJOUT ET A LA MODIF, ET AU RETOUR APRES ERREUR
	. charger la liste des auteurs, puis celle des categories. 
	. afficher ensuite la page
-------------------------------------------------------------------------------------------------*/

function charger_donnees_afficher (request, response, zechange) {
	odb.charger_liste_auteurs(  request, response, zechange, function() {
		odb.charger_liste_categories(  request, response, zechange, function() {
			omep.afficher_page(request, response, c_livres_vue_modif, zechange);
		});
	});

}

